Option Strict Off

Imports System.IO
Imports System.Text
Imports System.Collections
Imports System.Threading.Tasks
Imports System.Threading
Imports System.Net
Imports System.Reflection
Imports System.Collections.Concurrent
Imports System.Linq.Expressions
Imports System.Runtime.CompilerServices
Imports System.Web.Script.Serialization
Imports System.Runtime.Serialization
Imports System.Dynamic
Imports Microsoft.Visual Basic.RuntimeBinder

Namespace MapReduce
    '//////////////////////////////////////////////////
    ' How to call from aspx page:
    '
    '    <script src="jquery-1.4.1.min.js" type="text/javascript"></script>
    '
    '    <script language="javascript" type="text/javascript">
    '        function Button1_onclick() {
    '            $(function () {
    '                $.ajax({
    '                    type: "GET",
    '                    url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=Sales>=10&sort=ISBN',
    '                    //url: 'http://localhost/MapReducePortal/BookSales?distributednodes=Node1,Node2,Node3&union=ISBN&sum=Sales&where=BookName==Book A,or BookName==Book C&sort=ISBN',
    '                    //url: 'http://localhost/MapReducePortal/Alarms?distributednodes=Node1,Node2,Node3&union=AlarmGuid&sum=AlarmDuration&where=Severity==Critical,and AlarmDuration>10&sort=CreateDate',
    '                    data: '',
    '                    contentType: 'application/json; charset=utf-8',
    '                    dataType: 'json',
    '                    success: function (data) {
    '                        var output = BuildTable(data);
    '                        $('#div1').html(output0);
    '
    '                        $('#divErrors').hide;
    '                        if (output1 != null) {
    '                            $('#divErrors').show;
    '                            $('#divErrors').html(output1);
    '                        }
    '                    },
    '                    error: function (data) {
    '                        $('#b1').html(data.responseText);
    '                        alert("Error");
    '                    }
    '                });
    '            });
    '        }
    '    </script>
    '
    '    <html>
    '        <body>
    '            <h2>
    '                <input id="Button1" type="button" value="Test" onclick="return Button1_onclick()" />
    '            </h2>
    '            <br />
    '            <div id="div1"></div>
    '            <br />
    '            <div id="divErrors" style="display: none;"></div>
    '        </body>
    '    </html>
    '
    '
    ' Web.config on IIS 7.0:
    '    <system.webServer>
    '      <modules>
    '        <add name="MapReduceModule" type="MapReduce.MapReduceModule" />
    '      </modules>
    '    </system.webServer>
    '
    ' Put MapReduceModule.dll in the /bin directory of the virtual directory on IIS.
    '
    ' To allow test simulation all on one node:
    ' 1) Add virtual directory for: MapReduceData1, MapReduceData2, MapReduceData3
    ' 2) Put MapReduceModule.dll in the /bin directory under: MapReduceData1, MapReduceData2, MapReduceData3
    ' 3) Do ajax request using: Node1, Node2, Node3  (i.e. distributednodes=Node1,Node2,Node3)
    '
    ' To debug:
    ' 1) Open MapReduceModule project in Visual Studio
    ' 2) Select 'Attach to Process...' in Debug menu in Visual Studio
    ' 3) Attach to 'w3wp.exe'
    '    (Note: If no w3wp.exe, then run aspx page one time, retry, and w3wp.exe should now show in list
    '           If multiple w3wp.exe's show in list, then choose the one that is for MapReduceModule, not aspx page)
    '
    ' Note: Make sure the IIS virtual directory is using an AppPool that is using .Net Framework 4.0.
    '       Define a new AppPool using .Net Framework 4.0, if no other AppPool exists that is using .Net Framework 4.0.
    '
    ' Note: Can also set 'Maximum Worker Processes' to a number larger than the default of 1.
    '       This will allow there to be more w3wp.exe processes doing work in parallel.
    '       (Be careful if setting to more then 1 worker process because the static lists,
    '       dictionaries, etc will be destroyed and recreated when worker process recycles.)
    '       To change setting right click our AppPool and choose 'Advanced Settings'
    '          Go to 'Process Model' section and click 'Maximum Worker Processes' entry
    '             Change value from 1 to the new number of worker processes
    '
    ' Note: Right now we only allow distributed "getting", and do not allow any distributed "setting".
    '       (i.e.  we only allow the Read of CRUD, we do not allow the Create, Update, Delete of CRUD)
    '       We only allow http method GET and POST. (POST does not indicate to create a new item;
    '       it only indicates the "chaining" of GET calls, and that the data in the request body
    '       is the results from a previous GET call that should be merged with the results of the
    '       current GET call)
    '//////////////////////////////////////////////////

#Region "MapReduceModule"
    Public Class MapReduceModule
        Implements IHttpModule

        Public Sub Dispose() Implements IHttpModule.Dispose
        End Sub

        Public Sub Init(ByVal context As HttpApplication) Implements IHttpModule.Init
            context.AddOnBeginRequestAsync(New BeginEventHandler(AddressOf OnBeginMap), New EndEventHandler(AddressOf OnEndMap))
            context.AddOnEndRequestAsync(New BeginEventHandler(AddressOf OnBeginReduce), New EndEventHandler(AddressOf OnEndReduce))

            'load URI template table once at startup with all methods marked with PathInfoAttribute
            context.Application.Lock()
            If context.Application("URITemplateTable") Is Nothing Then
                'string baseUri = context.Context.Request.Url.Scheme + "://" + context.Context.Request.Url.Host + context.Context.Request.CurrentExecutionFilePath;
                Dim baseUri As String = context.Context.Request.Url.AbsoluteUri
                context.Application("URITemplateTable") = New UriTemplateTable(New Uri(baseUri))

                Dim types() As Type = System.Reflection.Assembly.GetExecutingAssembly.GetTypes
                For Each type As Type In types
                    Dim mis() As MethodInfo = type.GetMethods(BindingFlags.Static Or BindingFlags.Public)
                    For Each mi As MethodInfo In mis
                        Dim attributes() As Object = mi.GetCustomAttributes(GetType(BusinessObjects.PathInfoAttribute), False)
                        If attributes.GetLength(0) > 0 Then
                            Dim attribReturnItemType As String = (CType(attributes(0), BusinessObjects.PathInfoAttribute)).ReturnItemType
                            Dim atrribPathInfo As String = (CType(attributes(0), BusinessObjects.PathInfoAttribute)).PathInfo
                            Dim template As New UriTemplate(atrribPathInfo)
                            CType(context.Application("URITemplateTable"), UriTemplateTable).KeyValuePairs.Add(New KeyValuePair(Of UriTemplate, Object)(template, New Tuple(Of MethodInfo, String)(mi, attribReturnItemType)))
                        End If
                    Next mi
                Next type
                CType(context.Application("URITemplateTable"), UriTemplateTable).MakeReadOnly(False)
            End If
            context.Application.UnLock()
        End Sub

        Private Function OnBeginMap(ByVal sender As Object, ByVal e As EventArgs, ByVal cb As AsyncCallback, ByVal extraData As Object) As IAsyncResult
            Dim application As HttpApplication = CType(sender, HttpApplication)

            'force client calls to get new data every time
            application.Response.ExpiresAbsolute = Date.Now.Subtract(New TimeSpan(1, 0, 0, 0))
            application.Response.Expires = -1

            'encoding
            application.Response.ContentType = "application/json"
            application.Response.ContentEncoding = Encoding.UTF8

            'only allow http methods GET and POST
            If application.Request.HttpMethod <> "GET" AndAlso application.Request.HttpMethod <> "POST" Then
                application.Context.Response.Clear()
                application.Context.Response.ClearContent()
                application.Context.Response.StatusCode = 400 '400 (BadRequest)
                application.Context.Response.SubStatusCode = Integer.MaxValue 'custom indicator to skip the processing in the reduce step
                application.Context.Response.Write(JsonError(New Exception("Http method can only be GET or POST (PUT, DELETE, etc. are not implemented.")))
                application.Context.Response.Flush()
                application.Context.ApplicationInstance.CompleteRequest()
            End If

            'thread-safe containers for url query string parameters, data, and errors
            Dim actions As New ConcurrentDictionary(Of String, Object)
            Dim data As New ConcurrentDictionary(Of String, Object)
            Dim errors As New ConcurrentBag(Of String)

            'resulting data from previous call can be sent in as input data in post call
            '(used for chaining ajax calls to allow multiple levels (tiers) of mapreduce calls)
            If application.Request.HttpMethod = "POST" Then
                'Dim bytes = application.Request.BinaryRead(application.Request.TotalBytes);
                'Dim input = application.Request.ContentEncoding.GetString(bytes);
                Dim input As String = New StreamReader(application.Request.InputStream).ReadToEnd
                application.Request.InputStream.Position = 0
                data.TryAdd("PostData", input)
            End If

            'edge nodes that will be part of distributed request
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("DistributedNodes")) Then
                actions.TryAdd("DistributedNodes", application.Context.Request.QueryString("DistributedNodes").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            End If

            'aggregations
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("Sum")) Then
                actions.TryAdd("Sum", application.Context.Request.QueryString("Sum").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            End If

            'operations
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("Union")) Then
                actions.TryAdd("Union", application.Context.Request.QueryString("Union").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            ElseIf Not String.IsNullOrEmpty(application.Context.Request.QueryString("Intersect")) Then
                actions.TryAdd("Intersect", application.Context.Request.QueryString("Intersect").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            ElseIf Not String.IsNullOrEmpty(application.Context.Request.QueryString("Except")) Then
                actions.TryAdd("Except", application.Context.Request.QueryString("Except").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            ElseIf Not String.IsNullOrEmpty(application.Context.Request.QueryString("SymmetricExcept")) Then
                actions.TryAdd("SymmetricExcept", application.Context.Request.QueryString("SymmetricExcept").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            End If

            'custom function
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("Reduce")) Then
                actions.TryAdd("Reduce", application.Context.Request.QueryString("Reduce"))
            End If

            'filter
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("Where")) Then
                actions.TryAdd("Where", application.Context.Request.QueryString("Where").Split(New Char() {","c}, StringSplitOptions.RemoveEmptyEntries))
            End If

            'sort
            If Not String.IsNullOrEmpty(application.Context.Request.QueryString("Sort")) Then
                actions.TryAdd("Sort", application.Context.Request.QueryString("Sort"))
            ElseIf Not String.IsNullOrEmpty(application.Context.Request.QueryString("SortAsc")) Then
                actions.TryAdd("SortAsc", application.Context.Request.QueryString("SortAsc"))
            ElseIf Not String.IsNullOrEmpty(application.Context.Request.QueryString("SortDesc")) Then
                actions.TryAdd("SortDesc", application.Context.Request.QueryString("SortDesc"))
            End If

            'add containers to HttpContext
            SyncLock application.Context.Items.SyncRoot
                application.Context.Items.Add("#Actions#", actions)
                application.Context.Items.Add("#Data#", data)
                application.Context.Items.Add("#Errors#", errors)
            End SyncLock

            'launch thread to do map requests without blocking pipeline
            Dim wc As WaitCallback = AddressOf DoMap
            Return wc.BeginInvoke(application.Context, cb, application.Context)
        End Function

        Private Sub OnEndMap(ByVal ar As IAsyncResult)
            Dim result As System.Runtime.Remoting.Messaging.AsyncResult = CType(ar, System.Runtime.Remoting.Messaging.AsyncResult)
            Dim d As WaitCallback = CType(result.AsyncDelegate, WaitCallback)
            d.EndInvoke(ar)
        End Sub

        Private Sub DoMap(ByVal state As Object)
            Dim context As HttpContext = CType(state, HttpContext)

            'launch each map request on its own thread and wait until all are done to continue
            Dim nodes As List(Of Tuple(Of String, HttpContext)) = BuildNodesList(context)
            Dim options As New ParallelOptions
            options.MaxDegreeOfParallelism = CInt(Fix(10)) 'make this a setting in the web.config
            Parallel.ForEach(nodes, options, New Action(Of Tuple(Of String, HttpContext))(AddressOf DoRequest))
        End Sub

        Private Function BuildNodesList(ByVal context As HttpContext) As List(Of Tuple(Of String, HttpContext))
            Dim list As New List(Of Tuple(Of String, HttpContext))

            'get distributed edge nodes
            If (CType(context.Items("#Actions#"), ConcurrentDictionary(Of String, Object))).ContainsKey("DistributedNodes") Then
                Dim distributedNodes() As String = CType((CType(context.Items("#Actions#"), ConcurrentDictionary(Of String, Object)))("DistributedNodes"), String)
                For Each nodeName As String In distributedNodes
                    list.Add(New Tuple(Of String, HttpContext)(nodeName, context))
                Next nodeName
            End If

            'always add self
            list.Add(New Tuple(Of String, HttpContext)("#Self#", context))

            Return list
        End Function

        Private Sub DoRequest(ByVal state As Tuple(Of String, HttpContext))
            '////////////////////////////////////////////////////////////////////////////////////////
            'This method is called here on the local node that initiated the request, and this exact
            'same method is called out on the edge nodes that were specified in the original request.
            'So when we are in this method we are either the local node or the edge node, and we need
            'to either invoke a local method (self) or invoke a web request (edge).
            '(e.g.  Self request = data method invoked on local node
            '       Not Self request = web request invoked to edge node)
            '
            '              <local-node>                       <edge-node>
            '               /       \                          /       \
            '    <self request>   <not self request>   <self request>   <not self request>
            '                                                           (not implemented)
            '
            'Right now we only allow ONE level of hierarchy because we remove any of the
            ''not self request' from the URL query string in the web request that we send to
            'the edge node. As a future enhancement we could leave them and allow MULTIPLE levels of
            'hierarchy. We could have a hierarchy of nodes within the same mesh, or a hierarchy of
            'meshes where meshes contain meshes. We could then make recursive calls on the hierarchy.
            '////////////////////////////////////////////////////////////////////////////////////////

            Dim uri As String = String.Empty
            Try
                'build uri
                uri = state.Item2.Request.Url.Scheme & "://" & (If(state.Item1 Is "#Self#", state.Item2.Request.Url.Host, state.Item1)) + state.Item2.Request.Path

                'check if edge node (defaults to false if not specified)
                Dim edgeNode As Boolean = ((Not String.IsNullOrEmpty(state.Item2.Request.QueryString("EdgeNode"))) AndAlso state.Item2.Request.QueryString("EdgeNode").ToLower = "true")

                'check if include local node data (defaults to true if not specified)
                Dim includeLocalData As Boolean = Not ((Not String.IsNullOrEmpty(state.Item2.Request.QueryString("LocalData"))) AndAlso state.Item2.Request.QueryString("LocalData").ToLower = "false")

                If state.Item1 Is "#Self#" Then
                    '///////////////////////////////////
                    'local method invoked on local node
                    '///////////////////////////////////
                    Try
                        Dim js As New Script.Serialization.JavaScriptSerializer
                        js.RegisterConverters({New DynamicRowConverter(GetType(MapReduce.Row))})
                        Dim result As Object = Nothing

                        'check uri template table for method matching this request uri
                        Dim match As UriTemplateMatch = (CType(state.Item2.Application("URITemplateTable"), UriTemplateTable)).MatchSingle(New Uri(uri))
                        If match IsNot Nothing Then
                            Dim data As Tuple(Of MethodInfo, String) = CType(match.Data, Tuple(Of MethodInfo, String))

                            'get parameters for method
                            Dim pis() As ParameterInfo = data.Item1.GetParameters
                            Dim parameters(pis.GetLength(0) - 1) As Object
                            For i = 0 To pis.GetLength(0) - 1
                                parameters(i) = js.ConvertToType(match.BoundVariables(pis(i).Name).ToString, pis(i).ParameterType)
                            Next i

                            'store return item type that was specified in PathInfoAttribute
                            CType(state.Item2.Items("#Actions#"), ConcurrentDictionary(Of String, Object)).TryAdd("ReturnItemType", data.Item2)

                            'execute method and get results
                            result = data.Item1.Invoke(Nothing, parameters)
                        Else
                            Throw New Exception("Request URI does not match any URITemplate.")
                        End If

                        'serialize results
                        Dim sb As New StringBuilder
                        js.Serialize(result, sb)
                        If edgeNode Then
                            'write results to response stream
                            state.Item2.Response.Write(sb.ToString)
                            state.Item2.Response.StatusCode = 200
                            state.Item2.Response.SubStatusCode = Integer.MaxValue 'custom indicator to skip the processing in the reduce step on this edge node
                            state.Item2.Response.Flush()
                            state.Item2.ApplicationInstance.CompleteRequest() 'jump directly to reduce step in the pipeline on this edge node
                        Else
                            'store results in HttpContext for reduce step
                            If includeLocalData Then
                                CType(state.Item2.Items("#Data#"), ConcurrentDictionary(Of String, Object)).TryAdd("LocalData", sb.ToString)
                            End If
                        End If
                    Catch ex As Exception
                        Dim [error] As String = JsonError(uri, ex)
                        'Note: Return status code 400 (BadRequest) from this edge node so it will trigger a
                        'WebException back on the local node that initiated the web request (if return 200 (OK)
                        'or 204 (NoContent), then will NOT trigger WebException)
                        state.Item2.Response.StatusCode = 400
                        state.Item2.Response.SubStatusCode = Integer.MaxValue 'custom indicator to skip the processing in the reduce step on this edge node
                        state.Item2.Response.Write([error]) 'write error back as data in response stream along with 400 even though 400 will trigger WebException back at local node that initiated the web request
                        state.Item2.Response.Flush() 'need to flush here or will just return 404 (NotFound) because HttpModule only and no HttpHandler to handle request
                        state.Item2.ApplicationInstance.CompleteRequest() 'jump directly to reduce step in the pipeline on this edge node

                        'Note: Can choose whether to return 200 (OK) or 400 (BadRequest) here.
                        '      400 (BadRequest) will trigger WebException back on the local node that initiated the web request.
                        '      200 (OK) will NOT trigger WebException back on the local node that initiated the web request.
                        '      If return 200 (OK) then will need to parse the data that is returned from the web request looking for errors.
                        '      If return 400 (BadRequest) can catch WebException for errors.
                        '      After have errors back on local node that initiated web request, need to choose whether want to
                        '      return 200 (OK), 400 (BadRequest), or 500 (InternalServerError) from final reduce step back to the ajax call.
                        '      200 (OK) response will go to 'success:' handler of ajax call.
                        '      400 (BadRequest) or 500 (InternalServerError) response will go to 'error:' handler of ajax call.
                    End Try
                Else
                    '/////////////////////////////////////////////
                    'web request invoked to distributed edge node
                    '/////////////////////////////////////////////
                    Try
                        '						#Region "Testing - allows test simulation all on one node"
                        'Need to add virtual directory for: MapReduceData1, MapReduceData2, MapReduceData3
                        'Call with ajax request using: Node1, Node2, Node3
                        uri = state.Item2.Request.Url.Scheme & "://localhost" & state.Item2.Request.Path
                        If state.Item1 Is "Node1" Then
                            uri = uri.Replace("MapReducePortal", "MapReduceData1")
                        ElseIf state.Item1 Is "Node2" Then
                            uri = uri.Replace("MapReducePortal", "MapReduceData2")
                        ElseIf state.Item1 Is "Node3" Then
                            uri = uri.Replace("MapReducePortal", "MapReduceData3")
                        Else
                            Throw New Exception("Invalid node...")
                        End If
                        '						#End Region

                        'mark as request to distributed edge node
                        uri = uri & "?EdgeNode=true"

                        'do web request to distributed edge node
                        Dim webRequest As HttpWebRequest = CType(HttpWebRequest.Create(New Uri(uri)), HttpWebRequest)
                        webRequest.ContentType = "application/json; charset=utf-8"
                        webRequest.MediaType = "json"
                        webRequest.Timeout = Timeout.Infinite
                        Dim response As WebResponse = webRequest.GetResponse
                        Using sm As New StreamReader(response.GetResponseStream)
                            'get resulting data back from distributed edge node and put in HttpContext
                            Dim data As String = sm.ReadToEnd
                            If Not String.IsNullOrEmpty(data) Then
                                CType(state.Item2.Items("#Data#"), ConcurrentDictionary(Of String, Object)).TryAdd(uri, data)
                            End If
                        End Using
                    Catch ex As WebException
                        Dim [error] As String = String.Empty

                        'Note: This status code is 400 (BadRequest) because we set it to
                        '400 (BadRequest) in the error handler out on the edge node.
                        If (CType(ex.Response, HttpWebResponse)).StatusCode = HttpStatusCode.BadRequest Then
                            Using sr As New StreamReader(ex.Response.GetResponseStream)
                                [error] = sr.ReadToEnd
                            End Using
                        End If

                        If [error] = String.Empty Then
                            [error] = JsonError(uri, ex)
                        End If

                        If edgeNode Then
                            Throw New NotImplementedException("Multiple levels of hierarchy not implemented.")
                        Else
                            CType(state.Item2.Items("#Errors#"), ConcurrentBag(Of String)).Add([error])
                        End If
                    Catch ex As Exception
                        Dim [error] As String = JsonError(uri, ex)
                        If edgeNode Then
                            Throw New NotImplementedException("Multiple levels of hierarchy not implemented.")
                        Else
                            CType(state.Item2.Items("#Errors#"), ConcurrentBag(Of String)).Add([error])
                        End If
                    End Try
                End If
            Catch ex As Exception
                Dim [error] As String = JsonError(uri, ex)
                CType(state.Item2.Items("#Errors#"), ConcurrentBag(Of String)).Add([error])
            End Try
        End Sub

        Private Function OnBeginReduce(ByVal sender As Object, ByVal e As EventArgs, ByVal cb As AsyncCallback, ByVal extraData As Object) As IAsyncResult
            'launch thread to do reduce without blocking pipeline
            Dim application As HttpApplication = CType(sender, HttpApplication)
            Dim wc As WaitCallback = AddressOf DoReduce
            Return wc.BeginInvoke(application.Context, cb, Nothing)
        End Function

        Private Sub OnEndReduce(ByVal ar As IAsyncResult)
            Dim result As System.Runtime.Remoting.Messaging.AsyncResult = CType(ar, System.Runtime.Remoting.Messaging.AsyncResult)
            Dim d As WaitCallback = CType(result.AsyncDelegate, WaitCallback)
            d.EndInvoke(ar)
        End Sub

        Private Sub DoReduce(ByVal state As Object)
            Dim context As HttpContext = CType(state, HttpContext)

            'SubStatusCode=int.MaxValue is our custom indicator to skip procesing in reduce step
            If context.Response.SubStatusCode = Integer.MaxValue Then
                Exit Sub
            End If

            Try
                'Note: Status code at this point is usually 404 (NotFound) because there is no HttpHandler,
                'we change it and return 200 (OK) for everything and just include the errors in the data.
                context.Response.StatusCode = 200

                'do reduce
                If context.Items.Count > 0 Then
                    Dim ht As Hashtable = CType(context.Items, Hashtable)
                    Dim actions As ConcurrentDictionary(Of String, Object) = CType(ht("#Actions#"), ConcurrentDictionary(Of String, Object))
                    Dim data As ConcurrentDictionary(Of String, Object) = CType(ht("#Data#"), ConcurrentDictionary(Of String, Object))
                    Dim errors As ConcurrentBag(Of String) = CType(ht("#Errors#"), ConcurrentBag(Of String))

                    'aggregations
                    Dim sumKeys() As String = Nothing
                    If actions.ContainsKey("Sum") Then
                        sumKeys = CType(actions("Sum"), String)
                    End If

                    'operations
                    Dim keys() As String = Nothing
                    If actions.ContainsKey("Union") Then
                        keys = CType(actions("Union"), String)
                    ElseIf actions.ContainsKey("Intersect") Then
                        keys = CType(actions("Intersect"), String)
                    ElseIf actions.ContainsKey("Except") Then
                        keys = CType(actions("Except"), String)
                    ElseIf actions.ContainsKey("SymmetricExcept") Then
                        keys = CType(actions("SymmetricExcept"), String)
                    End If

                    'get return type of individual item in results
                    Dim returnItemType As String = String.Empty
                    If actions.ContainsKey("ReturnItemType") Then
                        returnItemType = CStr(actions("ReturnItemType"))
                    End If
                    If String.IsNullOrEmpty(returnItemType) Then
                        Throw New Exception("ReturnItemType not specified.")
                    End If
                    Dim typeReturnItem As Type = Type.GetType(returnItemType)

                    'custom function
                    Dim miCustomfunction As MethodInfo = Nothing
                    If actions.ContainsKey("Reduce") Then
                        Dim customFunctionName As String = CStr(actions("Reduce"))
                        Dim types() As Type = System.Reflection.Assembly.GetExecutingAssembly.GetTypes
                        For Each type As Type In types
                            Dim mi As MethodInfo = type.GetMethod(customFunctionName, BindingFlags.Instance Or BindingFlags.Static Or BindingFlags.NonPublic Or BindingFlags.Public)
                            If mi IsNot Nothing Then
                                'make sure method is marked with custom reduce function attribute
                                Dim attributes() As Object = mi.GetCustomAttributes(GetType(BusinessObjects.CustomReduceFunctionAttribute), False)
                                If attributes.GetLength(0) = 0 Then
                                    Throw New Exception("Custom reduce function specified [" & customFunctionName & "] has not been marked with [CustomReduceFunction] attribute.")
                                End If

                                'make sure signature is correct, it must be: static HashSet<MapReduce.Row> CustomFunctionName(HashSet<MapReduce.Row> currentData, HashSet<MapReduce.Row> newData)
                                Dim pis() As ParameterInfo = mi.GetParameters
                                If (Not mi.IsStatic) OrElse pis.GetLength(0) <> 2 OrElse mi.ReturnType IsNot GetType(HashSet(Of MapReduce.Row)) OrElse pis(0).ParameterType IsNot GetType(HashSet(Of MapReduce.Row)) OrElse pis(1).ParameterType IsNot GetType(HashSet(Of MapReduce.Row)) Then
                                    Throw New Exception("Custom function signature must be:  static HashSet[Row] CustomFunctionName(HashSet[Row] currentData, HashSet[Row] newData)")
                                End If

                                miCustomfunction = mi
                                Exit For
                            End If
                        Next type
                        If miCustomfunction Is Nothing Then
                            Throw New Exception("Custom function [" & customFunctionName & "] not found in this assembly.")
                        End If
                    End If

                    Dim js As New Script.Serialization.JavaScriptSerializer
                    js.RegisterConverters({New DynamicRowConverter(typeReturnItem)})

                    'get data from previous ajax request if was sent as input to this request
                    Dim postResults As HashSet(Of Row) = Nothing
                    If data.ContainsKey("PostData") Then
                        Dim tempPostResults As Object = js.Deserialize(CStr(data("PostData")), GetType(HashSet(Of Row)))
                        postResults = New HashSet(Of Row)(CType(tempPostResults, IEnumerable(Of Row)))
                    End If

                    'create final rows object that will be returned  (put in post results if there are any)
                    Dim rows As HashSet(Of Row) = Nothing
                    If postResults IsNot Nothing Then
                        rows = New HashSet(Of Row)(postResults, New ObjectEqualityComparer(keys, sumKeys))
                    Else
                        rows = New HashSet(Of Row)(New ObjectEqualityComparer(keys, sumKeys))
                    End If

                    'get local data and put in final rows object first
                    If data.ContainsKey("LocalData") Then
                        Dim tempLocalResults As Object = js.Deserialize(CStr(data("LocalData")), GetType(HashSet(Of Row)))
                        Dim localResults As New HashSet(Of Row)(CType(tempLocalResults, IEnumerable(Of Row)))
                        For Each item As Row In localResults
                            rows.Add(item)
                        Next item

                        'if custom function specified then execute custom function against local data
                        If rows.Count > 0 Then
                            If miCustomfunction IsNot Nothing Then
                                Dim currentRows As New HashSet(Of Row)
                                If keys IsNot Nothing AndAlso keys.GetLength(0) > 0 AndAlso sumKeys IsNot Nothing AndAlso sumKeys.GetLength(0) > 0 Then
                                    currentRows = New HashSet(Of Row)(New ObjectEqualityComparer(keys, sumKeys))
                                ElseIf keys IsNot Nothing AndAlso keys.GetLength(0) > 0 Then
                                    currentRows = New HashSet(Of Row)(New ObjectEqualityComparer(keys))
                                End If

                                Dim newRows As New HashSet(Of Row)(rows)
                                rows = CType(miCustomfunction.Invoke(rows, New Object() {currentRows, newRows}), HashSet(Of Row))
                            End If
                        End If
                    End If

                    'get data results from all the ajax calls to all the edge nodes
                    'and merge them into final rows object
                    For Each key As Object In data.Keys
                        If key IsNot Nothing AndAlso CStr(key) <> "LocalData" AndAlso CStr(key) <> "PostData" Then
                            Dim url As String = key.ToString
                            Dim nodeData As String = CStr(data(url))

                            'either perform custom reduce function or perform operation like union, intersect, etc.
                            Dim nodeResults As Object = js.Deserialize(nodeData, GetType(HashSet(Of Row)))
                            Dim newRows As New HashSet(Of Row)(CType(nodeResults, IEnumerable(Of Row)))
                            If miCustomfunction IsNot Nothing Then
                                'custom reduce function
                                rows = CType(miCustomfunction.Invoke(Nothing, New Object() {rows, newRows}), HashSet(Of Row))
                            Else
                                'operations
                                If actions.ContainsKey("Union") Then
                                    rows.UnionWith(newRows)
                                ElseIf actions.ContainsKey("Intersect") Then
                                    rows.IntersectWith(newRows)
                                ElseIf actions.ContainsKey("Except") Then
                                    rows.ExceptWith(newRows)
                                ElseIf actions.ContainsKey("SymmetricExcept") Then
                                    rows.SymmetricExceptWith(newRows)
                                Else
                                    rows.UnionWith(newRows)
                                End If
                            End If
                        End If
                    Next key

                    'prepare final results to be returned in response
                    If rows.Count > 0 Then
                        'filter (where clause)
                        If actions.ContainsKey("Where") Then
                            Dim whereExpressions() As String = CType(actions("Where"), String)
                            If whereExpressions IsNot Nothing AndAlso whereExpressions.GetLength(0) > 0 Then
                                Dim propertyNames() As String = Nothing
                                Dim p As Object = ReversePredicateBuilder(rows, whereExpressions, GetType(Row), propertyNames)
                                Dim whereRows As New HashSet(Of Row)(rows, New WhereObjectEqualityComparer(propertyNames))
                                whereRows.RemoveWhere(p)
                                'rows IEqualityComparer is lost when assign whereRows, but ok because we don't
                                'do anymore operations except serialize on rows object after this point before
                                'returning results to client
                                rows = whereRows
                            End If
                        End If

                        Dim sortField As String = String.Empty
                        Dim sortAscending As Boolean = True
                        If actions.ContainsKey("Sort") Then
                            sortField = CStr(actions("Sort"))
                        ElseIf actions.ContainsKey("SortAsc") Then
                            sortField = CStr(actions("SortAsc"))
                        ElseIf actions.ContainsKey("SortDesc") Then
                            sortField = CStr(actions("SortDesc"))
                            sortAscending = False
                        End If

                        'serialize final results
                        Dim sb As New StringBuilder
                        If Not String.IsNullOrEmpty(sortField) Then
                            'sort
                            Dim sortedRows As New List(Of Row)(rows)
                            sortedRows.Sort(New ObjectComparer(sortField, sortAscending))
                            js.Serialize(sortedRows, sb)
                        Else
                            js.Serialize(rows, sb)
                        End If

                        'if any errors, build errors envelope object around all errors
                        'and append to end of data just like another row of data
                        AppendJsonErrors(sb, errors)

                        'write response to response stream
                        context.Response.Write(sb.ToString)
                    Else
                        'if any errors, write errors to response stream (even if no data)
                        If errors.Count > 0 Then
                            Dim temp As String = JsonError(errors)
                            context.Response.Write(temp)
                        End If
                    End If
                End If
            Catch ex As Exception
                context.Response.Clear()
                context.Response.ClearContent()
                context.Response.StatusCode = 400 'returning 400 (BadRequest) response will go to 'error:' handler of ajax call.
                Dim [error] As String = JsonError(ex)
                'error = context.Server.HtmlEncode(error);
                context.Response.Write([error])
            Finally
                context.Response.Flush()
                context.Response.End()
            End Try
        End Sub

#Region "Helpers"
        Private Function JsonError(ByVal ParamArray exceptions() As Exception) As String
            Return JsonError(Nothing, exceptions)
        End Function

        Private Function JsonError(ByVal uri As String, ByVal ParamArray exceptions() As Exception) As String
            If exceptions.GetLength(0) = 0 Then
                Throw New ArgumentException("Must supply at least one Exception.", "exceptions")
            End If

            If exceptions.GetLength(0) = 1 Then
                If String.IsNullOrEmpty(uri) Then
                    Return "{""Error"":""" & exceptions(0).GetBaseException.Message & """}"
                Else
                    Return "{""Error"":""" & exceptions(0).GetBaseException.Message & """, ""URI"":""" & uri & """}"
                End If
            End If

            Dim sb As New StringBuilder
            sb.Append("{""Errors"":[")
            For Each ex As Exception In exceptions
                Dim [error] As String = String.Empty
                If String.IsNullOrEmpty(uri) Then
                    [error] = "{""Error"":""" & ex.GetBaseException.Message & """}"
                Else
                    [error] = "{""Error"":""" & ex.GetBaseException.Message & """, ""URI"":""" & uri & """}"
                End If
                sb.Append([error])
                sb.Append(","c)
            Next ex
            If sb(sb.Length - 1) = ","c Then
                sb.Replace(",", "]}", sb.Length - 1, 1)
            Else
                sb.Append("]}")
            End If

            Return sb.ToString
        End Function

        Private Function JsonError(ByVal errors As ConcurrentBag(Of String)) As String
            If errors.Count = 0 Then
                Throw New ArgumentException("Must supply at least one error.", "errors")
            End If

            Dim sb As New StringBuilder
            sb.Append("{""Errors"":[")
            For Each [error] As String In errors
                sb.Append([error])
                sb.Append(","c)
            Next [error]
            If sb(sb.Length - 1) = ","c Then
                sb.Replace(",", "]}", sb.Length - 1, 1)
            Else
                sb.Append("]}")
            End If

            Return sb.ToString
        End Function

        Private Sub AppendJsonErrors(ByVal sb As StringBuilder, ByVal errors As ConcurrentBag(Of String))
            If errors.Count > 0 Then
                Dim data As Boolean = sb.Length > 0
                If data Then
                    sb.Remove(sb.Length - 1, 1)
                    sb.Append(","c)
                End If
                sb.Append("{""Errors"":[")
                For Each [error] As String In errors
                    sb.Append([error])
                    sb.Append(","c)
                Next [error]

                If sb(sb.Length - 1) = ","c Then
                    sb.Replace(",", "]}", sb.Length - 1, 1)
                Else
                    sb.Append("]}")
                End If

                If data Then
                    sb.Append("]"c)
                End If
            End If
        End Sub

        Private Shared Function ReversePredicateBuilder(ByVal instance As HashSet(Of Row), ByVal expressions() As String, ByVal predicateObjectType As Type, <System.Runtime.InteropServices.Out> ByRef propertyNames() As String) As Object
            'Builds a predicate from a string.
            'Allows multiple expressions that are delimited by a comma, and have an 'and' or an 'or' between them.
            '(i.e. "BookName == Book A, and ID == 1, and Sales == 10")
            '
            'Example:
            'Pass in this:  "BookName == Book A, and ID == 1, and Sales == 10"
            'Builds predicate like this:  b => (((b.BookName != "Book A") OrElse (b.ID != Parse("1"))) OrElse (b.Sales != Parse("10")))
            '
            'Used to build a Predicate from a string passed as a query string parameter in a URL:
            'http://.../BookSales?where=BookName==Book A,and ID==1,and Sales==10
            '
            'Note: Reverses the operator and operation because this Predicate gets passed to
            'HashSet.RemoveWhere instead of just a Where. (i.e. RemoveWhere vs. Where)

            If expressions Is Nothing OrElse expressions.GetLength(0) = 0 Then
                Throw New ArgumentException("No expressions supplied for 'where' parameter in URL query string.", "expressions")
            End If
            If instance Is Nothing OrElse instance.Count = 0 Then
                Throw New ArgumentException("Result set was empty or null. Result set must have records for 'where' parameter in URL query string to build valid Predicate.", "instance")
            End If

            'build expression
            Dim p = Expression.Parameter(predicateObjectType, "b")
            Dim predicateType = GetType(Predicate(Of )).MakeGenericType(predicateObjectType)
            Dim body As BinaryExpression = Nothing
            Dim propertyNamesList As New List(Of String)

            For Each expression As String In expressions
                If expression.Contains("==") Then
                    Dim parts() As String = expression.Split(New String() {"=="}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, "==", parts(1).Trim, propertyNamesList)
                ElseIf expression.Contains("!=") Then
                    Dim parts() As String = expression.Split(New String() {"!="}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, "!=", parts(1).Trim, propertyNamesList)
                ElseIf expression.Contains("<=") Then
                    Dim parts() As String = expression.Split(New String() {"<="}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, "<=", parts(1).Trim, propertyNamesList)
                ElseIf expression.Contains(">=") Then
                    Dim parts() As String = expression.Split(New String() {">="}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, ">=", parts(1).Trim, propertyNamesList)
                ElseIf expression.Contains("<") Then
                    Dim parts() As String = expression.Split(New String() {"<"}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, "<", parts(1).Trim, propertyNamesList)
                ElseIf expression.Contains(">") Then
                    Dim parts() As String = expression.Split(New String() {">"}, StringSplitOptions.RemoveEmptyEntries)
                    If parts.GetLength(0) <> 2 Then
                        Throw New Exception("Expression [" & expression & "] is invalid.")
                    End If
                    body = ExpressionBuilder(instance, p, body, parts(0).Trim, ">", parts(1).Trim, propertyNamesList)
                Else
                    Throw New Exception("No valid operator in expression for 'where' parameter in URL query string.")
                End If
            Next expression

            propertyNames = propertyNamesList.ToArray

            'create predicate
            Dim predicate = Expression.Lambda(predicateType, body, p)
            Dim del As Object = predicate.Compile
            Return del
        End Function

        Private Shared Function ExpressionBuilder(ByVal instance As HashSet(Of Row), ByVal p As ParameterExpression, ByVal existingExpression As BinaryExpression, ByVal propertyName As String, ByVal operatorString As String, ByVal propertyValue As String, ByRef propertyNames As List(Of String)) As BinaryExpression
            If String.IsNullOrEmpty(operatorString) Then
                Throw New ArgumentException("Must supply valid operator string.", operatorString)
            End If

            Dim newExpression As BinaryExpression = Nothing

            'determine append operation
            Dim operation As String = String.Empty
            If propertyName.StartsWith("and ") Then
                operation = "and"
                propertyName = propertyName.Replace("and ", "")
            ElseIf propertyName.StartsWith("or ") Then
                operation = "or"
                propertyName = propertyName.Replace("or ", "")
            End If

            'store all property names to return
            propertyNames.Add(propertyName)

            'get property type
            Dim rows(0) As Row
            instance.CopyTo(rows, 0, 1)
            Dim propertyType As Type = rows(0).GetPropertyType(propertyName)

            'build expression
            Dim miGetPropertyValue As MethodInfo = GetType(Row).GetMethod("GetPropertyValue", BindingFlags.Public OrElse BindingFlags.Instance)
            Dim propertyGetValue = Expression.Call(p, miGetPropertyValue, Expression.Constant(propertyName))
            Dim propertyKey = Expression.Convert(propertyGetValue, propertyType)
            Dim value = Expression.Constant(propertyValue, GetType(String))
            Dim mi As MethodInfo = propertyType.GetMethod("Parse", BindingFlags.Static Or BindingFlags.Public, Nothing, New Type() {GetType(String)}, Nothing)
            If mi IsNot Nothing Then
                Dim parse = Expression.Call(mi, value)
                If operatorString = "==" Then
                    newExpression = Expression.NotEqual(propertyKey, parse)
                ElseIf operatorString = "!=" Then
                    newExpression = Expression.Equal(propertyKey, parse)
                ElseIf operatorString = "<=" Then
                    newExpression = Expression.GreaterThan(propertyKey, parse)
                ElseIf operatorString = ">=" Then
                    newExpression = Expression.LessThan(propertyKey, parse)
                ElseIf operatorString = "<" Then
                    newExpression = Expression.GreaterThanOrEqual(propertyKey, parse)
                ElseIf operatorString = ">" Then
                    newExpression = Expression.LessThanOrEqual(propertyKey, parse)
                End If
            Else
                If operatorString = "==" Then
                    newExpression = Expression.NotEqual(propertyKey, value)
                ElseIf operatorString = "!=" Then
                    newExpression = Expression.Equal(propertyKey, value)
                ElseIf operatorString = "<=" Then
                    newExpression = Expression.GreaterThan(propertyKey, value)
                ElseIf operatorString = ">=" Then
                    newExpression = Expression.LessThan(propertyKey, value)
                ElseIf operatorString = "<" Then
                    newExpression = Expression.GreaterThanOrEqual(propertyKey, value)
                ElseIf operatorString = ">" Then
                    newExpression = Expression.LessThanOrEqual(propertyKey, value)
                End If
            End If

            'append expression
            If existingExpression Is Nothing Then
                Return newExpression
            Else
                If operation = "and" Then
                    Return Expression.Or(existingExpression, newExpression)
                ElseIf operation = "or" Then
                    Return Expression.And(existingExpression, newExpression)
                Else
                    Return Expression.Or(existingExpression, newExpression)
                End If
            End If
        End Function
#End Region

    End Class
#End Region

#Region "Dynamic Row Object"
    <Serializable()>
    Public Class Row
        Inherits DynamicObject
        Implements ISerializable

        Private _properties As New Dictionary(Of String, Object)

        Public Sub New()
        End Sub

        Public Sub New(ByVal properties As IDictionary(Of String, Object))
            _properties = CType(properties, Dictionary(Of String, Object))
        End Sub

        Public Sub New(ByVal properties As IDictionary(Of String, Object), ByVal type As Type, ByVal serializer As JavaScriptSerializer)
            Dim convertedDictionary As New Dictionary(Of String, Object)
            For Each key As String In properties.Keys
                convertedDictionary.Add(key, serializer.ConvertToType(properties(key), type.GetProperty(key).PropertyType))
            Next key
            _properties = convertedDictionary
        End Sub

        Public Overrides Function TryGetIndex(ByVal binder As GetIndexBinder, ByVal indexes() As Object, <System.Runtime.InteropServices.Out> ByRef result As Object) As Boolean
            If _properties.ContainsKey(indexes(0).ToString) Then
                result = _properties(indexes(0).ToString)
                Return True
            Else
                result = Nothing
                Return False
            End If
        End Function

        Public Overrides Function TrySetIndex(ByVal binder As SetIndexBinder, ByVal indexes() As Object, ByVal value As Object) As Boolean
            If Not _properties.ContainsKey(indexes(0).ToString) Then
                _properties.Add(indexes(0).ToString, value)
                Return True
            Else
                _properties(indexes(0).ToString) = value
                Return True
            End If
        End Function

        Public Overrides Function TryGetMember(ByVal binder As GetMemberBinder, <System.Runtime.InteropServices.Out> ByRef result As Object) As Boolean
            If _properties.ContainsKey(binder.Name) Then
                result = _properties(binder.Name)
                Return True
            Else
                result = Nothing
                Return False
            End If
        End Function

        Public Overrides Function TrySetMember(ByVal binder As SetMemberBinder, ByVal value As Object) As Boolean
            If Not _properties.ContainsKey(binder.Name) Then
                _properties.Add(binder.Name, value)
                Return True
            Else
                _properties(binder.Name) = value
                Return True
            End If
        End Function

        Public Overrides Function TryConvert(ByVal binder As ConvertBinder, <System.Runtime.InteropServices.Out> ByRef result As Object) As Boolean
            'Explicit cast operations trigger this method.
            '(i.e. an explicit cast from dynamic object to a concrete type,
            'like explicit cast from Row to Book)
            Dim newType As Object = Activator.CreateInstance(binder.Type)
            If newType Is Nothing Then
                result = newType
                Return False
            Else
                For Each pi As PropertyInfo In binder.Type.GetProperties(BindingFlags.Public OrElse BindingFlags.Instance)
                    pi.SetValue(newType, (CType(Me, Object))(pi.Name), Nothing)
                Next pi
                result = newType
                Return True
            End If
        End Function

        Public Function GetProperties() As Dictionary(Of String, Object)
            Return _properties
        End Function

        Public Iterator Function GetPropertyNames() As IEnumerable(Of String)
            For Each propertyName As String In _properties.Keys
                Yield propertyName
            Next propertyName
        End Function

        Public Function GetPropertyValue(ByVal propertyName As String) As Object
            If Not _properties.ContainsKey(propertyName) Then
                Throw New Exception("Property [" & propertyName & "] does not exist on object [Row].")
            End If

            Return _properties(propertyName)
        End Function

        Public Function GetPropertyType(ByVal propertyName As String) As Type
            If Not _properties.ContainsKey(propertyName) Then
                Throw New Exception("Property [" & propertyName & "] does not exist on object [Row].")
            End If

            Return _properties(propertyName).GetType
        End Function

        Public Function IsPropertyExist(ByVal propertyName As String) As Boolean
            Return _properties.ContainsKey(propertyName)
        End Function

        Public Shared Sub ConvertList(ByVal sourceList As List(Of Row), ByVal targetList As Object)
            targetList.Clear()

            'Converts list of dynamic objects into list of concrete type objects.
            'The dynamic object will be converted into whatever type the target list holds.
            Dim type As Type = targetList.GetType.GetGenericArguments(0)
            For Each item As Object In sourceList
                Dim newItem = DynamicHelper.ExplicitCast(item, type)
                targetList.Add(newItem)
            Next item
        End Sub

#Region "Serialization"
        Public Sub New(ByVal info As SerializationInfo, ByVal context As StreamingContext)
            For Each key In info
                Dim item As Object = Me
                item(key.Name) = key.Value
            Next key
        End Sub
        Public Sub GetObjectData(ByVal info As SerializationInfo, ByVal context As StreamingContext) Implements ISerializable.GetObjectData
            For Each k As String In _properties.Keys
                info.AddValue(k, _properties(k))
            Next k
        End Sub
#End Region

    End Class

    Public Class DynamicRowConverter
        Inherits JavaScriptConverter

        Private _schemaType As Type = Nothing
        Private _types As New Dictionary(Of String, Type)

        Public Sub New(ByVal schemaType As Type)
            _schemaType = schemaType

            For Each pi As PropertyInfo In _schemaType.GetProperties(BindingFlags.Public OrElse BindingFlags.Instance)
                _types.Add(pi.Name, pi.PropertyType)
            Next pi
        End Sub

        Private Sub New()
        End Sub

        Public Overrides Function Deserialize(ByVal dictionary As IDictionary(Of String, Object), ByVal type As Type, ByVal serializer As JavaScriptSerializer) As Object
            If type Is GetType(Row) Then
                Dim newDictionary As New Dictionary(Of String, Object)
                For Each key As String In dictionary.Keys
                    If _types.ContainsKey(key) Then
                        newDictionary.Add(key, serializer.ConvertToType(dictionary(key), _types(key)))
                    Else
                        newDictionary.Add(key, dictionary(key))
                    End If
                Next key
                Dim row As New Row(newDictionary)
                Return row
            Else
                Throw New Exception("Type not supported.")
            End If
        End Function

        Public Overrides Function Serialize(ByVal obj As Object, ByVal serializer As JavaScriptSerializer) As IDictionary(Of String, Object)
            If TypeOf obj Is Row Then
                Dim temp As IDictionary(Of String, Object) = (CType(obj, Row)).GetProperties
                Return temp
            Else
                Throw New Exception("Type not supported.")
            End If
        End Function

        Public Overrides ReadOnly Property SupportedTypes As IEnumerable(Of Type)
            Get
                Return {GetType(Row)}
            End Get
        End Property
    End Class

    Public NotInheritable Class DynamicHelper
        Private Shared _castCache As ConcurrentDictionary(Of Type, Object) = Nothing

        Shared Sub New()
            _castCache = New ConcurrentDictionary(Of Type, Object)
        End Sub

        Public Shared Function ExplicitCast(ByVal item As Object, ByVal castTo As Type) As Object
            'This utility method casts a custom dynamic type (that implements TryConvert) to a concrete type using type variables at runtime (instead of generic types at compile time).
            'It basically triggers an explicit cast that in turn triggers a call to TryConvert on the custom dynamic object.
            'This utility method caches the callsite used for casting the custom dynamic type based on the castTo type as a key.
            'Note: If custom dynamic type has more properties than concrete type, cast will still work, but it will only fill in propeties on concrete type and disregard the additonal properties on the custom dynamic type.
            'Note: If custom dynamic type does not have a property that exists on concrete type, cast will fail.
            'Note: Only use this to cast from a custom dynamic type (that implements TryConvert) to a regular concrete type.
            If _castCache.ContainsKey(castTo) Then
                Dim callsite As Object = _castCache(castTo)
                Dim val = callsite.Target(callsite, item)
                Return val
            Else
                Dim t As Type = GetType(Func(Of ,,))
                Dim typeCallSite As Type = GetType(CallSite)
                Dim typeItem As Type = item.GetType
                Dim typeFunc As Type = t.MakeGenericType(typeCallSite, typeItem, castTo)
                Dim binder = Microsoft.Visual Basic.RuntimeBinder.Binder.Convert(CSharpBinderFlags.ConvertExplicit, castTo, Nothing)
                Dim callsite As Object = System.Runtime.CompilerServices.CallSite.Create(typeFunc, binder)
                Dim val = callsite.Target(callsite, item)

                _castCache.TryAdd(castTo, callsite)

                Return val
            End If
        End Function


    End Class
#End Region

#Region "Comparers"
    Friend Class ObjectEqualityComparer
        Implements IEqualityComparer(Of Row)

        Private _keyStrings() As String = Nothing
        Private _sumKeyStrings() As String = Nothing

        Public Sub New(ByVal keys() As String)
            _keyStrings = keys
        End Sub

        Public Sub New(ByVal keys() As String, ByVal sumKeys() As String)
            _keyStrings = keys
            _sumKeyStrings = sumKeys
        End Sub

        Public Overloads Function Equals(ByVal x As Row, ByVal y As Row) As Boolean Implements IEqualityComparer(Of Row).Equals
            If _keyStrings Is Nothing OrElse _keyStrings.GetLength(0) = 0 Then
                Return False
            End If

            Dim dx As Object = x
            Dim dy As Object = y
            For Each key As String In _keyStrings
                If Not x.IsPropertyExist(key) Then
                    Throw New Exception("Property [" & key & "] does not exist on object [Row].")
                End If

                Dim result As Integer = CInt(Fix(dx(key).CompareTo(dy(key))))
                If result <> 0 Then
                    Return False
                End If
            Next key
            If _sumKeyStrings IsNot Nothing Then
                For Each key As String In _sumKeyStrings
                    If Not x.IsPropertyExist(key) Then
                        Throw New Exception("Property [" & key & "] does not exist on object [Row].")
                    End If

                    Dim sumValue As Object = dx(key) + dy(key)
                    dx(key) = sumValue
                Next key
            End If
            Return True
        End Function

        Public Overloads Function GetHashCode(ByVal obj As Row) As Integer Implements IEqualityComparer(Of Row).GetHashCode
            If _keyStrings Is Nothing OrElse _keyStrings.GetLength(0) = 0 Then
                Return 0
            End If

            Dim d As Object = obj
            Dim sb As New StringBuilder
            For Each key As String In _keyStrings
                If Not obj.IsPropertyExist(key) Then
                    Throw New Exception("Property [" & key & "] does not exist on object [Row].")
                End If

                sb.Append(d(key).ToString)
            Next key
            Return sb.ToString.GetHashCode
        End Function
    End Class

    Friend Class ObjectComparer
        Implements IComparer(Of Row)

        Private _sortField As String = String.Empty
        Private _ascending As Boolean = True

        Public Sub New(ByVal sortField As String)
            _sortField = sortField
        End Sub

        Public Sub New(ByVal sortField As String, ByVal ascending As Boolean)
            _sortField = sortField
            _ascending = ascending
        End Sub

        Public Function Compare(ByVal x As Row, ByVal y As Row) As Integer Implements IComparer(Of Row).Compare
            Dim result As Integer = 0

            If Not String.IsNullOrEmpty(_sortField) Then
                Dim dx As Object = x
                Dim dy As Object = y

                If Not x.IsPropertyExist(_sortField) Then
                    Throw New Exception("Property [" & _sortField & "] does not exist on object [Row].")
                End If

                If dx(_sortField) Is Nothing AndAlso dy(_sortField) Is Nothing Then
                    Return 0
                End If

                If _ascending Then
                    If dx(_sortField) Is Nothing Then
                        Return -1
                    End If
                    If dy(_sortField) Is Nothing Then
                        Return 1
                    End If

                    Return CInt(Fix(dx(_sortField).CompareTo(dy(_sortField))))
                Else
                    If dx(_sortField) Is Nothing Then
                        Return 1
                    End If
                    If dy(_sortField) Is Nothing Then
                        Return -1
                    End If

                    Return CInt(Fix(dy(_sortField).CompareTo(dx(_sortField))))
                End If
            End If
            Return result
        End Function
    End Class

    Friend Class WhereObjectEqualityComparer
        Implements IEqualityComparer(Of Row)

        Private _whereStrings() As String = Nothing

        Public Sub New(ByVal whereKeys() As String)
            _whereStrings = whereKeys
        End Sub

        Public Overloads Function Equals(ByVal x As Row, ByVal y As Row) As Boolean Implements IEqualityComparer(Of Row).Equals
            If _whereStrings Is Nothing OrElse _whereStrings.GetLength(0) = 0 Then
                Return False
            End If

            Dim dx As Object = x
            Dim dy As Object = y
            For Each key As String In _whereStrings
                If Not x.IsPropertyExist(key) Then
                    Throw New Exception("Property [" & key & "] does not exist on object [Row].")
                End If

                Dim result As Integer = CInt(Fix(dx(key).CompareTo(dy(key))))
                If result <> 0 Then
                    Return False
                End If
            Next key
            Return True
        End Function

        Public Overloads Function GetHashCode(ByVal obj As Row) As Integer Implements IEqualityComparer(Of Row).GetHashCode
            If _whereStrings Is Nothing OrElse _whereStrings.GetLength(0) = 0 Then
                Return 0
            End If

            Dim d As Object = obj
            Dim sb As New StringBuilder
            For Each key As String In _whereStrings
                If Not obj.IsPropertyExist(key) Then
                    Throw New Exception("Property [" & key & "] does not exist on object [Row].")
                End If

                sb.Append(d(key).ToString)
            Next key
            Return sb.ToString.GetHashCode
        End Function
    End Class
#End Region

End Namespace

#Region "BusinessObjects - Put all the business data objects here..."
Namespace BusinessObjects

	#Region "Attributes to use on business data objects"
	<AttributeUsage(AttributeTargets.Method, AllowMultiple := False)>
	Public Class PathInfoAttribute
		Inherits Attribute

		Public Property PathInfo As String

		Public Property ReturnItemType As String
	End Class

	<AttributeUsage(AttributeTargets.Method, AllowMultiple := False)>
	Public Class CustomReduceFunctionAttribute
		Inherits Attribute
	End Class
	#End Region

	#Region "BookSales object - Used for testing"
	<Serializable()>
	Public Class Book
		Public Property ID As Integer

		Public Property BookName As String

		Public Property ISBN As Guid

		Public Property Sales As Integer

		Public Property PublishDate As Date
	End Class

	<Serializable()>
	Public Class BookSales
		Inherits ReadOnlyCollectionBase

        'Example to test operations (like union, sum, etc) and sorting
		<PathInfo(PathInfo := "/BookSales", ReturnItemType := "BusinessObjects.Book")>
		Public Shared Function [Get]() As BookSales
			Dim items As New BookSales
			If System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReducePortal") Then
                'throw new Exception("test error on LocalNode...");
				items.InnerList.Add(New Book With {.ID = 1, .BookName = "Book A", .ISBN = New Guid("11111111-1111-1111-1111-111111111111"), .Sales = 10, .PublishDate = New Date(2011, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Book With {.ID = 2, .BookName = "Book B", .ISBN = New Guid("22222222-2222-2222-2222-222222222222"), .Sales = 30, .PublishDate = New Date(2012, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Book With {.ID = 3, .BookName = "Book C", .ISBN = New Guid("33333333-3333-3333-3333-333333333333"), .Sales = 20, .PublishDate = New Date(2013, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData1") Then
                'throw new Exception("test error on Node1...");
				items.InnerList.Add(New Book With {.ID = 4, .BookName = "Book D", .ISBN = New Guid("44444444-4444-4444-4444-444444444444"), .Sales = 5, .PublishDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData2") Then
                'throw new Exception("test error on Node2...");
				items.InnerList.Add(New Book With {.ID = 5, .BookName = "Book E", .ISBN = New Guid("55555555-5555-5555-5555-555555555555"), .Sales = 20, .PublishDate = New Date(2015, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData3") Then
                'throw new Exception("test error on Node3...");
				items.InnerList.Add(New Book With {.ID = 3, .BookName = "Book C", .ISBN = New Guid("33333333-3333-3333-3333-333333333333"), .Sales = 5, .PublishDate = New Date(2013, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Book With {.ID = 4, .BookName = "Book D", .ISBN = New Guid("44444444-4444-4444-4444-444444444444"), .Sales = 1, .PublishDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			End If
			Return items
		End Function

		<PathInfo(PathInfo := "/BookSales/GetTotalBookSalesByBookName/{bookName}", ReturnItemType := "BusinessObjects.Book")>
		Public Shared Function GetTotalBookSalesByBookName(ByVal bookName As String) As BookSales
			Dim items As New BookSales
			If System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReducePortal") Then
				If bookName = "Book A" Then
					items.InnerList.Add(New Book With {.ID = 1, .BookName = "Book A", .ISBN = New Guid("11111111-1111-1111-1111-111111111111"), .Sales = 10, .PublishDate = New Date(2011, 4, 1, 0, 0, 0, 0)})
				ElseIf bookName = "Book B" Then
					items.InnerList.Add(New Book With {.ID = 2, .BookName = "Book B", .ISBN = New Guid("22222222-2222-2222-2222-222222222222"), .Sales = 30, .PublishDate = New Date(2012, 4, 1, 0, 0, 0, 0)})
				ElseIf bookName = "Book C" Then
					items.InnerList.Add(New Book With {.ID = 3, .BookName = "Book C", .ISBN = New Guid("33333333-3333-3333-3333-333333333333"), .Sales = 20, .PublishDate = New Date(2013, 4, 1, 0, 0, 0, 0)})
				End If
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData1") Then
				If bookName = "Book D" Then
					items.InnerList.Add(New Book With {.ID = 4, .BookName = "Book D", .ISBN = New Guid("44444444-4444-4444-4444-444444444444"), .Sales = 5, .PublishDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
				End If
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData2") Then
				If bookName = "Book E" Then
					items.InnerList.Add(New Book With {.ID = 5, .BookName = "Book E", .ISBN = New Guid("55555555-5555-5555-5555-555555555555"), .Sales = 20, .PublishDate = New Date(2015, 4, 1, 0, 0, 0, 0)})
				End If
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData3") Then
				If bookName = "Book C" Then
					items.InnerList.Add(New Book With {.ID = 3, .BookName = "Book C", .ISBN = New Guid("33333333-3333-3333-3333-333333333333"), .Sales = 5, .PublishDate = New Date(2013, 4, 1, 0, 0, 0, 0)})
				ElseIf bookName = "Book D" Then
					items.InnerList.Add(New Book With {.ID = 4, .BookName = "Book D", .ISBN = New Guid("44444444-4444-4444-4444-444444444444"), .Sales = 1, .PublishDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
				End If
			End If
			Return items
		End Function

		'//////////////////////////////////////
		'Examples of custom reduce function
		'//////////////////////////////////////
		<CustomReduceFunction>
		Private Shared Function PublishDateFilter(ByVal currentData As HashSet(Of MapReduce.Row), ByVal newData As HashSet(Of MapReduce.Row)) As HashSet(Of MapReduce.Row)
			currentData.UnionWith(newData)

			'dynamic required in order to compile (will be resolved at runtime)
            Dim p As Predicate(Of Object) = Function(a) a.PublishDate < New Date(2013, 4, 1, 0, 0, 0, 0)
			currentData.RemoveWhere(p)

			Return currentData
		End Function
	End Class
	#End Region

	#Region "Alarms object - Used for testing"
	<Serializable()>
	Public Class Alarm
		Public Property AlarmID As Integer

		Public Property Description As String

		Public Property AlarmGuid As Guid

		Public Property AlarmDuration As Double

		Public Property Severity As String

		Public Property Count As Integer

		Public Property CreateDate As Date
	End Class

	<Serializable()>
	Public Class Alarms
		Inherits ReadOnlyCollectionBase

		'Example to test operations (like union, sum, etc) and sorting
		<PathInfo(PathInfo := "/Alarms", ReturnItemType := "BusinessObjects.Alarm")>
		Public Shared Function [Get]() As Alarms
			Dim items As New Alarms
			If System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReducePortal") Then
                'throw new Exception("test error on LocalNode...");
				items.InnerList.Add(New Alarm With {.AlarmID = 100, .Description = "alarm1", .AlarmGuid = New Guid("11111111-1111-1111-1111-111111111111"), .Severity = "Critical", .AlarmDuration = 1.1, .Count = 1, .CreateDate = New Date(2011, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Alarm With {.AlarmID = 2, .Description = "alarm2", .AlarmGuid = New Guid("22222222-2222-2222-2222-222222222222"), .Severity = "Warning", .AlarmDuration = 2.2, .Count = 1, .CreateDate = New Date(2012, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Alarm With {.AlarmID = 3, .Description = "alarm3", .AlarmGuid = New Guid("33333333-3333-3333-3333-333333333333"), .Severity = "Major", .AlarmDuration = 4.4, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData1") Then
                'throw new Exception("test error on Node1...");
				items.InnerList.Add(New Alarm With {.AlarmID = 4, .Description = "alarm4", .AlarmGuid = New Guid("11111111-1111-1111-1111-111111111111"), .Severity = "Critical", .AlarmDuration = 4.4, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData2") Then
                'throw new Exception("test error on Node2...");
				items.InnerList.Add(New Alarm With {.AlarmID = 4, .Description = "alarm5", .AlarmGuid = New Guid("22222222-2222-2222-2222-222222222222"), .Severity = "Critical", .AlarmDuration = 5.5, .Count = 1, .CreateDate = New Date(2016, 4, 1, 0, 0, 0, 0)})
			ElseIf System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData3") Then
                'throw new Exception("test error on Node3...");
				items.InnerList.Add(New Alarm With {.AlarmID = 4, .Description = "alarm4", .AlarmGuid = New Guid("33333333-3333-3333-3333-333333333333"), .Severity = "Critical", .AlarmDuration = 4.4, .Count = 1, .CreateDate = New Date(2017, 4, 1, 0, 0, 0, 0)})
				items.InnerList.Add(New Alarm With {.AlarmID = 4, .Description = "alarm6", .AlarmGuid = New Guid("11111111-1111-1111-1111-111111111111"), .Severity = "Warning", .AlarmDuration = 6.6, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			End If
			Return items
		End Function

        'Examples of custom reduce function
		<CustomReduceFunction>
		Private Shared Function AlarmDurationThreshold(ByVal currentData As HashSet(Of MapReduce.Row), ByVal newData As HashSet(Of MapReduce.Row)) As HashSet(Of MapReduce.Row)
			currentData.UnionWith(newData)

			'dynamic required in order to compile (will be resolved at runtime)
            Dim p As Predicate(Of Object) = Function(a) a.AlarmDuration > 4.0
			currentData.RemoveWhere(p)

			Return currentData
		End Function

		<CustomReduceFunction>
		Private Shared Function AlarmSeverityFilter(ByVal currentData As HashSet(Of MapReduce.Row), ByVal newData As HashSet(Of MapReduce.Row)) As HashSet(Of MapReduce.Row)
			currentData.UnionWith(newData)

			'dynamic required in order to compile (will be resolved at runtime)
			Dim p As Predicate(Of Object) = Function(a) a.Severity = "Warning"
			currentData.RemoveWhere(p)

			Return currentData
		End Function

        'Examples to test URITemplate matches
		<PathInfo(PathInfo := "/Alarms/{alarmID}", ReturnItemType := "BusinessObjects.Alarm")>
		Public Shared Function [Get](ByVal alarmID As Integer) As Alarms
			Dim items As New Alarms
			items.InnerList.Add(New Alarm With {.AlarmID = alarmID, .Description = "alarm1", .AlarmGuid = New Guid("11111111-1111-1111-1111-111111111111"), .Severity = "Critical", .AlarmDuration = 1.1, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			Return items
		End Function

		<PathInfo(PathInfo := "/Alarms/{alarmID}/{description}", ReturnItemType := "BusinessObjects.Alarm")>
		Public Shared Function [Get](ByVal alarmID As Integer, ByVal description As String) As Alarms
			Dim items As New Alarms
			items.InnerList.Add(New Alarm With {.AlarmID = alarmID, .Description = description, .AlarmGuid = New Guid("22222222-2222-2222-2222-222222222222"), .Severity = "Warning", .AlarmDuration = 3.3, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			Return items
		End Function

		<PathInfo(PathInfo := "/Alarms/{alarmID}/{description}/{alarmGuid}", ReturnItemType := "BusinessObjects.Alarm")>
		Public Shared Function [Get](ByVal alarmID As Integer, ByVal description As String, ByVal alarmGuid As Guid) As Alarms
			Dim items As New Alarms
			items.InnerList.Add(New Alarm With {.AlarmID = alarmID, .Description = description, .AlarmGuid = alarmGuid, .Severity = "Critical", .AlarmDuration = 4.4, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			Return items
		End Function

        <PathInfo(PathInfo:="/Alarms/{alarmID}/{description}/{alarmGuid}/{duration}", ReturnItemType:="BusinessObjects.Alarm")>
        Public Shared Function [Get](ByVal alarmID As Integer, ByVal description As String, ByVal alarmGuid As Guid, ByVal duration As Double) As Alarms
            Dim items As New Alarms
            items.InnerList.Add(New Alarm With {.AlarmID = alarmID, .Description = description, .AlarmGuid = alarmGuid, .Severity = "Major", .AlarmDuration = duration, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})

            If System.Reflection.Assembly.GetExecutingAssembly.CodeBase.Contains("MapReduceData3") Then
                Throw New Exception("test error on Node3...")
            End If

            Return items
        End Function

		<PathInfo(PathInfo := "/Alarms/GetByGuid/{alarmGuid}", ReturnItemType := "BusinessObjects.Alarm")>
		Public Shared Function GetByGuid(ByVal alarmGuid As Guid) As Alarms
			Dim items As New Alarms
			items.InnerList.Add(New Alarm With {.AlarmID = 2, .Description = "alarm2", .AlarmGuid = alarmGuid, .Severity = "Critical", .AlarmDuration = 2.2, .Count = 1, .CreateDate = New Date(2014, 4, 1, 0, 0, 0, 0)})
			Return items
		End Function
	End Class
	#End Region

	#Region "CheeseBurgerWorkflow object - Used for testing workflow"
	<Serializable()>
	Public Class KeyValuePair
		Public Property Key As Object

		Public Property Value As Object
	End Class

	<Serializable()>
	Public Class CheeseBurgerWorkflow
		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step1", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step1() As HashSet(Of KeyValuePair)
			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step1", .Value = "Bottom Bun"})
			Return [step]
		End Function

		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step2", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step2() As HashSet(Of KeyValuePair)
			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step2", .Value = "Hamburger Patty"})
			Return [step]
		End Function

		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step3", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step3() As HashSet(Of KeyValuePair)
			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step3", .Value = "Cheese"})
			Return [step]
		End Function

		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step4", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step4() As HashSet(Of KeyValuePair)
			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step4", .Value = "Lettuce"})
			Return [step]
		End Function

		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step5", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step5() As HashSet(Of KeyValuePair)
			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step5", .Value = "Tomato"})
			Return [step]
		End Function

		<PathInfo(PathInfo := "/CheeseBurgerWorkflow/Step6", ReturnItemType := "BusinessObjects.KeyValuePair")>
		Public Shared Function Step6() As HashSet(Of KeyValuePair)
            'throw new Exception("test error on Step6...");

			'do some work for this workflow step
			Dim [step] As New HashSet(Of KeyValuePair)
			[step].Add(New KeyValuePair With {.Key = "Step6", .Value = "Top Bun"})
            Return [step]
		End Function
	End Class
	#End Region

#Region "Famous 'Hello World' Example - Used for testing"
    <Serializable()>
    Public Class Utilities
        <PathInfo(PathInfo:="/WordCount/{documentName}", ReturnItemType:="MapReduce.Row")>
        Public Shared Function GetWordCount(ByVal documentName As String) As HashSet(Of MapReduce.Row)
            Dim rows As New HashSet(Of MapReduce.Row)()
            'Note: Need to put Test.txt file in each node's virtual directory next to the web.config file (NOT in \bin directory).
            Dim bytes() As Byte = File.ReadAllBytes(AppDomain.CurrentDomain.BaseDirectory & documentName)
            Dim text As String = Encoding.ASCII.GetString(bytes)
            Dim words() As String = text.Split(New Char() {" "c, ControlChars.Cr, ControlChars.Lf})
            For Each word As String In words
                Dim row As Object = New MapReduce.Row
                row("Word") = word
                row("Count") = 1
                rows.Add(row)
            Next word
            Return rows
        End Function
    End Class
#End Region

End Namespace
#End Region
